import pygame
import euclid
import math
import random

import twist

WIDTH, HEIGHT = 512, 512

def get_twist_force(position, dir = 1.0):
    into = (euclid.Point2(WIDTH/2, HEIGHT/2) - position)

    rotation = euclid.Matrix3.new_rotate(dir * math.pi / 2.0)
    around = rotation * into

    into = into.normalized() * into.magnitude() * 0.001 * 0.5
    around = around.normalized() / around.magnitude() * 0.5

    return into + around

def run():
    pygame.init()

    screen = pygame.display.set_mode((WIDTH,HEIGHT))

    done = False
    
    dir = 1.0

    rand = random.Random()

    spawn_pos = euclid.Point2(WIDTH/2, HEIGHT/2)
    spawn_pos_move_to = euclid.Point2(WIDTH/2, HEIGHT/2)

    spawn_color = [random.randint(0,256), random.randint(0,256), random.randint(0,256)]
    spawn_color_move_to = [random.randint(0,256), random.randint(0,256), random.randint(0,256)]
    frame = 0

    clock = pygame.time.Clock()

    objects = []

    while not done:
        for event in pygame.event.get():
            if event.type == pygame.QUIT:
                done = True
		"""
            elif event.type == pygame.MOUSEBUTTONDOWN:
                position = euclid.Point2(event.pos[0], event.pos[1])
                mass = 1.0
		color = (event.pos[0]/2, event.pos[1]/2, 255)

                objects.append(twist.Object(position,mass,color))
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_SPACE:
                    dir = -dir
		"""
            elif event.type == pygame.KEYDOWN:
                if event.key == pygame.K_ESCAPE:
                    done = True

        if frame % 50 == 0:
            #spawn_pos.x = math.cos(frame/100.0)*(WIDTH/4-1)+(WIDTH/4-1)
            #spawn_pos.y = math.sin(frame/100.0)*(HEIGHT/4)+HEIGHT/4
            diff = spawn_pos_move_to - spawn_pos

            FOO = 10

            if diff.magnitude() < 2*FOO:
                spawn_pos_move_to.x = rand.random() * WIDTH
                spawn_pos_move_to.y = rand.random() * HEIGHT
                diff = spawn_pos_move_to - spawn_pos

            if diff.x > FOO:
                spawn_pos.x += FOO 
            elif diff.x < -FOO:
                spawn_pos.x -= FOO

            if diff.y > FOO:
                spawn_pos.y += FOO
            elif diff.y < -FOO:
                spawn_pos.y -= FOO

            mass = 1.0

            FOO = 5

            if abs(spawn_color[0] - spawn_color_move_to[0]) < 2*FOO and \
               abs(spawn_color[1] - spawn_color_move_to[1]) < 2*FOO and \
               abs(spawn_color[2] - spawn_color_move_to[2]) < 2*FOO:
                   spawn_color_move_to[0] = random.randint(0,256)
                   spawn_color_move_to[1] = random.randint(0,256)
                   spawn_color_move_to[2] = random.randint(0,256)

            diff = (spawn_color_move_to[0] - spawn_color[0],
                    spawn_color_move_to[1] - spawn_color[1],
                    spawn_color_move_to[2] - spawn_color[2])

            if diff[0] > FOO:
                spawn_color[0] += FOO
            elif diff[0] < -FOO:
                spawn_color[0] -= FOO
            if diff[1] > FOO:
                spawn_color[1] += FOO
            elif diff[1] < -FOO:
                spawn_color[1] -= FOO
            if diff[2] > FOO:
                spawn_color[2] += FOO
            elif diff[2] < -FOO:
                spawn_color[2] -= FOO

            #color = (int(spawn_pos.x/2), int(spawn_pos.y/2), 255)
            color = (spawn_color[0], spawn_color[1], spawn_color[2])
    
            objects.append(twist.Object(spawn_pos.copy(),mass,color))

        frame += 1

        for object in objects:
            object.apply_force(get_twist_force(object.get_position(), dir))
            object.update()
	    pos = object.get_position()
	    if pos.x < -WIDTH or pos.x > 2 * WIDTH or pos.y < -HEIGHT or pos.y > 2 * HEIGHT:
                objects.remove(object)

        screen.fill((0,0,0))

        for object in objects:
            pos = object.get_position()
            pygame.draw.circle(screen, object.color, (int(pos.x),int(pos.y)), 10)
	    #pygame.draw.rect(screen, object.color, (int(pos.x), int(pos.y),1,1))

        pygame.display.flip()

        clock.tick(60)
