# This is my Twist physics engine ;-)

# It's going to run at a constant framerate to keep calculations simple

import euclid

class Object:
    def __init__(self, position, mass, color):
        if not isinstance(position, euclid.Point2):
            raise TypeError, 'Position must be an euclid.Point2'

        self._position = position
        self._mass = float(mass)
        self._velocity = euclid.Vector2(0.0, 0.0)
        self.color = color

    def apply_force(self, force):
        if not isinstance(force, euclid.Vector2):
            raise TypeError, 'Force must be an euclid.Vector2'

        self._velocity += force / self._mass

    def update(self):
        self._position += self._velocity

    def get_position(self):
        return euclid.Vector2(self._position.x, self._position.y)
